IntrospectorCleanupListener (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.web.util

## Class IntrospectorCleanupListener

- java.lang.Object
- - org.springframework.web.util.IntrospectorCleanupListener

- All Implemented Interfaces:
    EventListener, ServletContextListener

      public class IntrospectorCleanupListener
      extends Object
      implements ServletContextListener

  Listener that flushes the JDK's `JavaBeans Introspector` cache on web app shutdown. Register this listener in your `web.xml` to guarantee proper release of the web application class loader and its loaded classes.

  If the JavaBeans Introspector has been used to analyze application classes, the system-level Introspector cache will hold a hard reference to those classes. Consequently, those classes and the web application class loader will not be garbage-collected on web app shutdown! This listener performs proper cleanup, to allow for garbage collection to take effect.

  Unfortunately, the only way to clean up the Introspector is to flush the entire cache, as there is no way to specifically determine the application's classes referenced there. This will remove cached introspection results for all other applications in the server too.

  Note that this listener is not necessary when using Spring's beans infrastructure within the application, as Spring's own introspection results cache will immediately flush an analyzed class from the JavaBeans Introspector cache and only hold a cache within the application's own ClassLoader. Although Spring itself does not create JDK Introspector leaks, note that this listener should nevertheless be used in scenarios where the Spring framework classes themselves reside in a 'common' ClassLoader (such as the system ClassLoader). In such a scenario, this listener will properly clean up Spring's introspection cache.

  Application classes hardly ever need to use the JavaBeans Introspector directly, so are normally not the cause of Introspector resource leaks. Rather, many libraries and frameworks do not clean up the Introspector: e.g. Struts and Quartz.

  Note that a single such Introspector leak will cause the entire web app class loader to not get garbage collected! This has the consequence that you will see all the application's static class resources (like singletons) around after web app shutdown, which is not the fault of those classes!

  This listener should be registered as the first one in `web.xml`, before any application listeners such as Spring's ContextLoaderListener. This allows the listener to take full effect at the right time of the lifecycle.

  Since:
    1.1
  Author:
    Juergen Hoeller
  See Also:
    `Introspector.flushCaches()`, `CachedIntrospectionResults.acceptClassLoader(java.lang.ClassLoader)`, `CachedIntrospectionResults.clearClassLoader(java.lang.ClassLoader)`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `IntrospectorCleanupListener()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `contextDestroyed(ServletContextEvent event)`
    `void` | `contextInitialized(ServletContextEvent event)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IntrospectorCleanupListener

          public IntrospectorCleanupListener()

  - ### Method Detail

    - #### contextInitialized

          public void contextInitialized(ServletContextEvent event)

      Specified by:
        `contextInitialized` in interface `ServletContextListener`

    - #### contextDestroyed

          public void contextDestroyed(ServletContextEvent event)

      Specified by:
        `contextDestroyed` in interface `ServletContextListener`